#!/usr/bin/env node

var path = require('path')
var [, , ...args] = process.argv
var program = require('commander');

program
	.version('1.0.0')
	.option('-d, --diretory [value]', 'Diretory')
	.option('-r, --root [value]', 'Root')
	.option('-h, --host [value]', 'Host')
	.option('-u, --user [value]', 'User')
	.option('-p, --port [value]', 'Port')
	.option('-w, --password [value]', 'Password')
	.parse(process.argv);
var term = require('terminal-kit').terminal;
var dir = path.resolve()
let json = null
try {
	json = require(path.join(dir, 'ftp.json'))
} catch (e) {
	console.log(e)
	json = {
		"host": program.host,
		"user": program.user,
		"password": program.password,
		"port": program.port
	}
}
if (typeof program.diretory == 'undefined') {
	term.bold.green('Diretory -d is required\n')
	process.exit()
	return false;
}
if (typeof program.root == 'undefined') {
	term.bold.green('Root -r is required\n')
	process.exit()
	return false;
}
if (program.root == '/') program.root = ''
if (typeof json.host == 'undefined') {
	term.bold.green('Host -h is required\n')
	process.exit()
	return false;
}
if (typeof json.user == 'undefined') {
	term.bold.green('User -u is required\n')
	process.exit()
	return false;
}
if (typeof json.password == 'undefined') {
	term.bold.green('Password -w is required\n')
	process.exit()
	return false;
}
if (typeof json.port == 'undefined') {
	term.bold.green('Port -p is required\n')
	process.exit()
	return false;
}

var walkSync = function (dir, filelist) {
	var fs = fs || require('fs'),
		files = fs.readdirSync(dir);
	filelist = filelist || [];
	files.forEach(function (file) {
		if (fs.statSync(dir + file).isDirectory()) {
			filelist = walkSync(dir + file + '/', filelist);
		} else {
			filelist.push({
				dir: dir,
				file: file
			});
		}
	});
	return filelist;
};
let filelist = []
try {
	filelist = walkSync(path.resolve(program.diretory) + '/')
} catch (e) {
	term.bold.red(e + '\n')
	process.exit()
	return false;
}
let _new = []
try {
	filelist.map((e) => {
		_new.push({
			file: e.file,
			dir: e.dir.replace(/\\\\/g, '').replace(/\//g, '\\').replace(dir, ''),
			completo: e.dir,
		})
	})
} catch (e) {
	term.bold.red(e + '\n')
	process.exit()
	return false;
}
var Ftp = require('ftp');
var client = new Ftp();
try {
	client.connect(json)

} catch (e) {
	term.bold.red('Error\n')
	process.exit()
	return false;
}
client.on('error', (e) => {
	term.bold.red(e + '\n')
	process.exit()
})
client.on('ready', (r) => {
	_new.map((i, indice) => {
		let caminho = (program.root + `/` + (i.dir)).replace(/\\/g, '/').replace(/\/\//g, '/')
		term.bold.green('Create Diretory: ' + caminho + '\n')
		client.mkdir(caminho, true, (e) => {
			if (indice == _new.length - 1) {
				_new.map((f, findice) => {
					let caminho_file_path = (program.root + `/` + (i.dir)).replace(/\\/g, '/').replace(/\/\//g, '/') + "/" + f.file
					term.bold.green('Create File: ' + f.file + '\n')
					client.put(path.join(i.completo, i.file), caminho_file_path, function (err) {
						if (findice == _new.length - 1) {
							term.bold.green('Success!')
							process.exit();
						}
					});
				})
			}
		})
	})
})